#pragma once

#include <amdis/linearalgebra/DOFMatrixBase.hpp>

namespace AMDiS
{
  template <class Matrix>
  struct Constraints
  {
    template <class R, class C, class B, class BitVector>
    static auto dirichletBC(DOFMatrixBase<R,C,B>& matrix, BitVector const& nodes, bool setDiagonal = true)
    {
      return Constraints<typename Matrix::BaseMatrix>::dirichletBC(matrix.matrix(), nodes, setDiagonal);
    }

    template <class R, class C, class B, class BitVector, class Association>
    static auto periodicBC(DOFMatrixBase<R,C,B>& matrix, BitVector const& left, Association const& association,
      bool setDiagonal = true)
    {
      return Constraints<typename Matrix::BaseMatrix>::periodicBC(matrix.matrix(), left, association, setDiagonal);
    }
  };

} // end namespace AMDiS
