#pragma once

#include <type_traits>

#include <amdis/localoperators/FirstOrderTestPartialTrial.hpp>

namespace AMDiS
{
  /**
   * \addtogroup operators
   * @{
   **/

  namespace tag
  {
    struct partialtest_trial
    {
      std::size_t comp;
    };
  }


  /// first-order operator \f$ \langle\partial_i\psi, c\,\phi\rangle \f$
  template <class LocalContext, class GridFct>
  class GridFunctionOperator<tag::partialtest_trial, LocalContext, GridFct>
      : public GridFunctionOperatorTransposed<GridFunctionOperator<tag::partialtest_trial, LocalContext, GridFct>,
                                              GridFunctionOperator<tag::test_partialtrial, LocalContext, GridFct>>
  {
    using Self = GridFunctionOperator;
    using Transposed = GridFunctionOperator<tag::test_partialtrial, LocalContext, GridFct>;
    using Super = GridFunctionOperatorTransposed<Self, Transposed>;

  public:
    GridFunctionOperator(tag::partialtest_trial tag, GridFct const& expr)
      : Super(tag::test_partialtrial{tag.comp}, expr)
    {}
  };

  /** @} **/

} // end namespace AMDiS
